/*
	ModifyArrayCmd.cc

	Will Eighteen, 2001, 2006: will@opaline.demon.co.uk
*/

#include "Application.h"
#include <DMenuCmd.h>
#include "OpResources.h"
#include "ModifyArrayCmd.h"
#include "AppWindow.h"
#include <MessageDialogManager.h>
#include <Xm/Label.h>
#include <Xm/Form.h>
#include <Xm/RowColumn.h>
#include <Xm/Protocols.h>
#include <Xm/TextF.h>
#include <Xm/PushB.h>
#include <GraphIntCmd.h>
#include <GraphFltCmd.h>


ModifyArrayCmd::ModifyArrayCmd ( char *name, int active, unsigned int numDigits, unsigned int fpDigits ) : NoUndoCmd ( name, active )
{
	_numDigits = numDigits;	// use resources, cut from constr?
	_fpDigits = fpDigits;
	_name = name;
	_modifyRealised = False;
	_templateRealised = False;
	_waveRealised = False;	
	_shift = 0;
	_scale = 1;
	_selectedItemNum = 0;
	_sourceType = -1;	// indeterminate
}


void ModifyArrayCmd::doCommand()
{
	if ( _modifyRealised == True )
		return;
	else
		_modifyRealised = True;
		
	int n;
	Arg args[4];
	Atom WM_DELETE_WINDOW;

	_popup = XtCreatePopupShell ( _name, transientShellWidgetClass,
									application->baseWidget(), NULL, 0 );

	_form = XtVaCreateManagedWidget ( "Form", xmFormWidgetClass, _popup,
										NULL );

	_label = XtCreateManagedWidget ( "Target:", xmLabelWidgetClass, _form, NULL, 0 );


	_rc0 = XtVaCreateManagedWidget ( "RowColumn0", xmRowColumnWidgetClass, _form,
				XmNorientation, XmHORIZONTAL,
				XmNnumColumns, 1,
				XmNpacking, XmPACK_COLUMN,
				XmNleftAttachment, XmATTACH_FORM,
				XmNrightAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, _label,
				NULL );

	_rc1 = XtVaCreateManagedWidget ( "RowColumn1", xmRowColumnWidgetClass, _form,
				XmNorientation, XmHORIZONTAL,
				XmNnumColumns, 1,
				XmNpacking, XmPACK_COLUMN,
				XmNleftAttachment, XmATTACH_FORM,
				XmNrightAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, _rc0,
				NULL );

	_rc2 = XtVaCreateManagedWidget ( "RowColumn2", xmRowColumnWidgetClass, _form,
				XmNorientation, XmVERTICAL,
				XmNnumColumns, 2,
				XmNpacking, XmPACK_COLUMN,
				XmNleftAttachment, XmATTACH_FORM,
				XmNrightAttachment, XmATTACH_FORM,
				XmNtopAttachment, XmATTACH_WIDGET,
				XmNtopWidget, _rc1,
				XmNbottomAttachment, XmATTACH_FORM,
				NULL );

    n = 0;

    XtSetArg ( args[n], XmNcolumns, _numDigits ); n++;
    XtSetArg ( args[n], XmNeditable, TRUE ); n++;
    XtSetArg ( args[n], XmNcursorPositionVisible, TRUE ); n++;
	XtSetArg ( args[n], XmNmaxLength, _numDigits+_fpDigits ); n++;

	_label1 = XtCreateManagedWidget ( "Shift", xmLabelWidgetClass, _rc0, NULL, 0 );
	_field1 = XtCreateManagedWidget ( "field1", xmTextFieldWidgetClass, _rc0, args, n );
	_label2 = XtCreateManagedWidget ( "Scale", xmLabelWidgetClass, _rc1, NULL, 0 );
	_field2 = XtCreateManagedWidget ( "field2", xmTextFieldWidgetClass, _rc1, args, n );

	XtAddCallback ( _field1, XmNactivateCallback,
					&ModifyArrayCmd::field1EntryCallback, ( XtPointer ) this );
	XtAddCallback ( _field2, XmNactivateCallback,
					&ModifyArrayCmd::field2EntryCallback, ( XtPointer ) this );

	_waveSel = XtVaCreateManagedWidget ( "Wave", xmPushButtonWidgetClass, _rc2, NULL, 0 );
	_modify = XtVaCreateManagedWidget ( "Execute", xmPushButtonWidgetClass, _rc2, NULL, 0 );
	_templateSel = XtVaCreateManagedWidget ( "Template", xmPushButtonWidgetClass, _rc2, NULL, 0 );
	_quit = XtVaCreateManagedWidget ( "Quit", xmPushButtonWidgetClass, _rc2, NULL, 0 );

	XtAddCallback ( _waveSel, XmNactivateCallback, &ModifyArrayCmd::waveSelCallback, ( XtPointer ) this );
	XtAddCallback ( _templateSel, XmNactivateCallback, &ModifyArrayCmd::templateSelCallback, ( XtPointer ) this );
	XtAddCallback ( _quit, XmNactivateCallback, &ModifyArrayCmd::quitCallback, ( XtPointer ) this );
	XtAddCallback ( _modify, XmNactivateCallback, &ModifyArrayCmd::modifyCallback, ( XtPointer ) this );

	// cater for WM 'X' pressed
	WM_DELETE_WINDOW = XmInternAtom ( XtDisplay ( _popup ), "WM_DELETE_WINDOW", False );
XmAddWMProtocols ( _popup, &WM_DELETE_WINDOW, 1 );
//	XmAddWMProtocolCallback ( _popup, WM_DELETE_WINDOW, clientMessageProc, ( XtPointer ) this );
XmAddWMProtocolCallback ( _popup, WM_DELETE_WINDOW, quitCallback, ( XtPointer ) this );

	changeField1 ( _shift );
	changeField2 ( _scale );

	XtPopup ( _popup, ( XtGrabKind ) XtGrabNone );
	XtManageChild ( _popup );
}


void ModifyArrayCmd::clientMessageProc ( Widget, XtPointer clientData, XmAnyCallbackStruct *cbs )
{
	ModifyArrayCmd *obj = ( ModifyArrayCmd * ) clientData;

	if ( obj->clientMessage( cbs ) )
		return;
}


int ModifyArrayCmd::clientMessage( XmAnyCallbackStruct *cbs )
{
	if ( cbs->reason == XmCR_PROTOCOLS )
	{
		quit();
		return 0;
	}
	
	return 1;
}


void ModifyArrayCmd::waveSelCallback ( Widget w, XtPointer clientData, XtPointer )
{
	ModifyArrayCmd *obj = ( ModifyArrayCmd * ) clientData;

	if ( obj->_waveRealised == False )
		obj->waveSel();
}


void ModifyArrayCmd::waveSel()
{
	if ( (*wavePak)[0].pWave->first() == NULL )
		return;

	unsigned int n;
	unsigned int maxNameLength = 0;
			
	_waveArrayItems = wavePak->Count();

	for ( n = 0; n < _waveArrayItems; n++ )
		if ( strlen ( (*wavePak)[n].pWave->name() ) > maxNameLength )
			maxNameLength = strlen ( (*wavePak)[n].pWave->name() );

	n = 0;
	maxNameLength++;
	
	if ( maxNameLength < 5 )
		maxNameLength = 5;	// accomodate 'quit' at a minimum
		
	_waveArrayItems++;
	
	char strings [ _waveArrayItems ] [ maxNameLength ];

	for ( n = 0; n < ( _waveArrayItems - 1 ); n++ )
		strcpy ( ( char * ) &strings [ n ], (*wavePak)[n].pWave->name() );

	strcpy ( strings [ n ], "Quit" );

	_waveMenu = new DMenuCmd ( "Wave shift/scale menu", TRUE, FALSE,
								&ModifyArrayCmd::waveMenuSelectionCallback,
								( void * ) this, "Current wave files",
								_waveArrayItems, maxNameLength, ( char * ) &strings );

	_waveRealised = True;
	_waveMenu->execute();
}


void ModifyArrayCmd::waveMenuSelectionCallback ( void *clientData, unsigned int selectedItemNum, char *label )
{
	ModifyArrayCmd *obj = ( ModifyArrayCmd * ) clientData;

	if ( ( selectedItemNum == obj->_waveArrayItems ) || ( selectedItemNum == 0 ) )	// 'quit menu' or WM 'X' selected
	{
		obj->_waveRealised = False;
		delete obj->_waveMenu;
	}
	else
		obj->waveSelected ( selectedItemNum );
}


void ModifyArrayCmd::waveSelected ( unsigned int selectedItemNum )
{
	if ( (*wavePak)[selectedItemNum-1].filePerm != 0 )	// not r/w
	{
		if ( mixwaveResources->enableMessagePopups() == True )
		{
			char buf[1024];
			snprintf ( buf, sizeof ( buf ), "%s\nNo write permission!",
						(*wavePak)[selectedItemNum-1].pWave->name() );
			buf [ sizeof ( buf ) - 1 ] = 0;
			messageDialogManager->post ( buf );
		}
		
		return;
	}

	// is the data available?
	if ( (*wavePak)[selectedItemNum-1].graphCmd == NULL )
	{
		// print msg showing error condition. 'wave view not realised
			char msg[1024];
			
			snprintf ( msg, sizeof ( msg ), "%s\nWave view not realised; use 'File/View/Wave'.",
						(*wavePak)[selectedItemNum-1].pWave->name() );
			msg [ sizeof ( msg ) - 1 ] = 0;			
			messageDialogManager->post ( msg );
	}
	else
	{
		_dataType = 0;
		_selectedItemNum = selectedItemNum;
		_sourceType = 1;	// type wave
		setTitle ( (*wavePak)[selectedItemNum-1].pWave->name() );
	}
}


void ModifyArrayCmd::templateSelCallback ( Widget w, XtPointer clientData, XtPointer )
{
	ModifyArrayCmd *obj = ( ModifyArrayCmd * ) clientData;

	if ( obj->_templateRealised == False )
		obj->templateSel();
}


void ModifyArrayCmd::templateSel()
{
	if ( templatePak->Count() == 0 )
		return;

	unsigned int n;
	unsigned int maxNameLength = 0;
	
	_templateArrayItems = templatePak->Count();

	for ( n = 0; n < _templateArrayItems; n++ )
		if ( strlen ( (*templatePak)[n].name ) > maxNameLength )
			maxNameLength = strlen ( (*templatePak)[n].name );

	n = 0;
	maxNameLength++;
	
	if ( maxNameLength < 5 )
		maxNameLength = 5;	// accomodate 'quit' at a minimum
		
	_templateArrayItems++;
	
	char strings [ _templateArrayItems ] [ maxNameLength ];

	for ( n = 0; n < ( _templateArrayItems - 1 ); n++ )
		strcpy ( ( char * ) &strings [ n ], (*templatePak)[n].name );

	strcpy ( strings [ n ], "Quit" );

	_templateMenu = new DMenuCmd ( "Template shift/scale menu", TRUE, FALSE,
								&ModifyArrayCmd::templateMenuSelectionCallback,
								( void * ) this, "Current template files",
								_templateArrayItems, maxNameLength, ( char * ) &strings );

	_templateRealised = True;
	_templateMenu->execute();
}


void ModifyArrayCmd::templateMenuSelectionCallback ( void *clientData, unsigned int selectedItemNum, char *label )
{
	ModifyArrayCmd *obj = ( ModifyArrayCmd * ) clientData;

	if ( strcmp ( label, "Quit" ) == 0 )
	{
		obj->_templateRealised = False;
		delete obj->_templateMenu;
	}
	else
	{
		int count, found;
		
		// scan base list for returned name
		for ( count = 0; count < templatePak->Count(); count++ )
		{
			found = 0;
			
			if ( strcmp ( label, (*templatePak)[count].name ) == 0 )
			{
				obj->templateSelected ( (*templatePak)[count].templateNum );
				found = 1;
				count = templatePak->Count();
			}
		}
		
		if ( !found && mixwaveResources->enableMessagePopups() == True )
		{
			char msg[BUFSIZE];

			snprintf ( msg, sizeof ( msg ), "Error: %s\nFile not loaded.", label );
			msg [ sizeof ( msg ) - 1 ] = 0;
			messageDialogManager->post ( msg );
		}
	}
}


void ModifyArrayCmd::templateSelected ( unsigned int selectedItemNum )
{
	// is the data available?
	if ( (*templatePak)[selectedItemNum-1].dataType == 0 )
	{
		if ( (*templatePak)[selectedItemNum-1].graphIntCmd == NULL )
		{
			// print msg showing error condition. 'wave view not realised
			char msg[BUFSIZE];
			
			snprintf ( msg, sizeof ( msg ), "%s\nTemplate view not realised\nUse \
'File/View/Template'.", (*templatePak)[selectedItemNum-1].name );
			msg [ sizeof ( msg ) - 1 ] = 0;
			messageDialogManager->post ( msg );
		}
		else
		{
			_dataType = 0;
			_selectedItemNum = selectedItemNum;
			_sourceType = 0;	// type template
			setTitle ( (*templatePak)[selectedItemNum-1].name );
		}
	}
	else
	{
		if ( (*templatePak)[selectedItemNum-1].graphFltCmd == NULL )
		{
			// print msg showing error condition. 'wave view not realised
			char msg[BUFSIZE];
			
			snprintf ( msg, sizeof ( msg ), "%s\nTemplate view not realised\nUse \
'File/View/Template'.", (*templatePak)[selectedItemNum-1].name );
			msg [ sizeof ( msg ) - 1 ] = 0;
			messageDialogManager->post ( msg );
  		}
		else
		{
			_dataType = 1;
			_selectedItemNum = selectedItemNum;
			_sourceType = 0;	// type template
			setTitle ( (*templatePak)[selectedItemNum-1].name );
		}
	}
}


void ModifyArrayCmd::setTitle ( char *title )
{
	stripName ( title );
	
	XmString xmstr1 = XmStringCreateSimple ( "Target: " );
	XmString xmstr2 = XmStringCreateSimple ( _labelString );
	XmString xmstr3 = XmStringConcat ( xmstr1, xmstr2 );
	XtVaSetValues ( _label, XmNlabelString, xmstr3, NULL );
	XmStringFree ( xmstr1 );
	XmStringFree ( xmstr2 );
	XmStringFree ( xmstr3 );
}


void ModifyArrayCmd::modifyCallback ( Widget, XtPointer clientData, XtPointer )
{
	ModifyArrayCmd *obj = ( ModifyArrayCmd * ) clientData;

	obj->modify();
}


void ModifyArrayCmd::modify()
{
	if ( _sourceType == -1 )
	{
		if ( mixwaveResources->enableMessagePopups() == True )
		{
			char msg[BUFSIZE];
		
			snprintf ( msg, sizeof ( msg ), "No wave or template selected.\nExecute failed." );
			msg [ sizeof ( msg ) - 1 ] = 0;
			messageDialogManager->post ( msg );
		}
		
		_selectedItemNum = 0;
		return;
	}

	switch ( _dataType )
	{
		case 0:	// int
			if ( _sourceType == 0 )
			{	// int template
				if ( (*templatePak)[_selectedItemNum-1].graphIntCmd != NULL )
				{
					_iData = (*templatePak)[_selectedItemNum-1].pIntArray;
					_startData = (*templatePak)[_selectedItemNum-1].startSel;
					_endData = (*templatePak)[_selectedItemNum-1].endSel;

					if ( ( _startData < (*templatePak)[_selectedItemNum-1].startRange ) ||
						( _endData > (*templatePak)[_selectedItemNum-1].endSel ) )
					{
						// print msg, 'selection not in view, use zoom in to view seln
						char msg[BUFSIZE];
				
						snprintf ( msg, sizeof ( msg ), "%s\nSelection not in view; use 'Zoom in'\nin \
template view.", (*templatePak)[_selectedItemNum-1].name );
						// keep the values anyway
						msg [ sizeof ( msg ) - 1 ] = 0;
						messageDialogManager->post ( msg );
					}
				}
				else
					return;
			}
			else
			{	// int wave
				if ( (*wavePak)[_selectedItemNum-1].graphCmd != NULL )
				{
					_iData = (*wavePak)[_selectedItemNum-1].pIntArray;
					_startData = (*wavePak)[_selectedItemNum-1].startSel;
					_endData = (*wavePak)[_selectedItemNum-1].endSel;

					if ( ( _startData < (*wavePak)[_selectedItemNum-1].startRange ) ||
						( _endData > (*wavePak)[_selectedItemNum-1].endSel ) )
					{
						// print msg, 'selection not in view, use zoom in to view seln
						char msg[BUFSIZE];
				
						snprintf ( msg, sizeof ( msg ), "%s\nSelection not in view; use 'Zoom in'\nin \
wave view.", (*wavePak)[_selectedItemNum-1].pWave->name() );
						// keep the values anyway
						msg [ sizeof ( msg ) - 1 ] = 0;
						messageDialogManager->post ( msg );
					}
				}
				else
					return;
			}

			break;
			
		case 1:	// float
			if ( _sourceType == 0 )	// make sure it's a template...
			{
				if ( (*templatePak)[_selectedItemNum-1].graphFltCmd != NULL )
				{
					_fData = (*templatePak)[_selectedItemNum-1].pFloatArray;
					_startData = (*templatePak)[_selectedItemNum-1].startSel;
					_endData = (*templatePak)[_selectedItemNum-1].endSel;

					if ( ( _startData < (*templatePak)[_selectedItemNum-1].startRange ) ||
						( _endData > (*templatePak)[_selectedItemNum-1].endSel ) )
					{
						// print msg, 'selection not in view, use zoom in to view seln
						char msg[BUFSIZE];
				
						snprintf ( msg, sizeof ( msg ), "%s\nSelection not in view; use 'Zoom in'\nin \
template view.", (*templatePak)[_selectedItemNum-1].name );
						// keep the values anyway
						msg [ sizeof ( msg ) - 1 ] = 0;
						messageDialogManager->post ( msg );
					}
				}
				else
					return;
			}
			
			break;
	}

	if ( _startData == _endData )
	{
		char msg[BUFSIZE];
		
		if ( _sourceType == 0 )
			snprintf ( msg, sizeof ( msg ), "%s\nNo selection, execute failed.",
						(*templatePak)[_selectedItemNum-1].name	);
		else
			snprintf ( msg, sizeof ( msg ), "%s\nNo selection, execute failed.",
						(*wavePak)[_selectedItemNum-1].pWave->name() );
		
		msg [ sizeof ( msg ) - 1 ] = 0;
		messageDialogManager->post ( msg );
		return;
	}

	long count, dataOffset;
	double value;

	if ( _dataType == 0 )	// int
	{
		if ( _sourceType == 0 )	// template
			dataOffset = (*templatePak)[_selectedItemNum-1].graphIntCmd->startData();
		else
			dataOffset = (*wavePak)[_selectedItemNum-1].graphCmd->startData();
	}
	else
		dataOffset = (*templatePak)[_selectedItemNum-1].graphFltCmd->startData();

	if ( _dataType == 0 )   // int
	{
		for ( count = _startData; count <= _endData; count ++ )
		{
			value = ( double ) _iData [ count - dataOffset ];
			value *= _scale;
			value += _shift;
			_iData [ count - dataOffset ] = ( int ) value;
        }
	}

	if ( _dataType == 1 )   // float
	{
		for ( count = _startData; count <= _endData; count ++ )
		{
			value = ( double ) _fData [ count - dataOffset ];
			value *= _scale;
			value += _shift;
			_fData [ count - dataOffset ] = ( float ) value;
        }
	}

	// now we signal an appropriate reload
	if ( _sourceType == 0 )	// template
	{
		(*templatePak)[_selectedItemNum-1].templateChanged = 1;

		if ( _dataType == 0 )
			(*templatePak)[_selectedItemNum-1].graphIntCmd->redisplay (
							(*templatePak)[_selectedItemNum-1].startRange,
							(*templatePak)[_selectedItemNum-1].endRange,
							(*templatePak)[_selectedItemNum-1].startSel,
							(*templatePak)[_selectedItemNum-1].endSel,
							(*templatePak)[_selectedItemNum-1].xCurrent,
							dataOffset );
		else
			(*templatePak)[_selectedItemNum-1].graphFltCmd->redisplay (
							(*templatePak)[_selectedItemNum-1].startRange,
							(*templatePak)[_selectedItemNum-1].endRange,
							(*templatePak)[_selectedItemNum-1].startSel,
							(*templatePak)[_selectedItemNum-1].endSel,
							(*templatePak)[_selectedItemNum-1].xCurrent,
							dataOffset );
	}
	else
	{
		(*wavePak)[_selectedItemNum-1].waveChanged = 1;	

		(*wavePak)[_selectedItemNum-1].graphCmd->redisplay (
							(*wavePak)[_selectedItemNum-1].startRange,
							(*wavePak)[_selectedItemNum-1].endRange,
							(*wavePak)[_selectedItemNum-1].startSel,
							(*wavePak)[_selectedItemNum-1].endSel,
							(*wavePak)[_selectedItemNum-1].xCurrent,
							dataOffset);
	}
}


void ModifyArrayCmd::quitCallback ( Widget w, XtPointer clientData, XtPointer )
{
	ModifyArrayCmd *obj = ( ModifyArrayCmd * ) clientData;

	obj->quit();
}


void ModifyArrayCmd::quit()
{
	if ( _waveRealised == True )
		delete _waveMenu;

	if ( _templateRealised == True )
		delete _templateMenu;

	_modifyRealised = False;
	_templateRealised = False;
	_waveRealised = False;
	XtDestroyWidget ( _popup );
}


void ModifyArrayCmd::field1EntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ModifyArrayCmd* obj = ( ModifyArrayCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field1 ) );
	text [ sizeof ( text ) - 1 ] = 0;
	
	if ( strlen ( text ) == 0 )
		obj->changeField1 ( 0 );

	obj->field1Entry ( text );
}


void ModifyArrayCmd::field2EntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ModifyArrayCmd* obj = ( ModifyArrayCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field2 ) );
	text [ sizeof ( text ) - 1 ] = 0;

	if ( strlen ( text ) == 0 )
		obj->changeField2 ( 1 );

	obj->field2Entry ( text );
}


void ModifyArrayCmd::field1Entry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField1 ( value );
	}
	else
		changeField1 ( 0 );
}


void ModifyArrayCmd::field2Entry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField2 ( value );
	}
	else
		changeField2 ( 1 );
}


void ModifyArrayCmd::changeField1 ( float value )
{
	char text[ _numDigits + _fpDigits + 1 ];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	_shift = value;
	sprintf ( text, "%f", value );
	XmTextFieldSetString ( _field1, text );
}


void ModifyArrayCmd::changeField2 ( float value )
{
	char text[ _numDigits + _fpDigits + 1];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	_scale = value;
	sprintf ( text, "%f", value );

	XmTextFieldSetString ( _field2, text );
}


int ModifyArrayCmd::checkTextEntry ( char *text )
{
	int error = 0;
	int length = strlen ( text );
	char c = 0;

	for ( int count = 0; count < length; count++ )
	{
		c = text [ count ];

		if ( ( c < '0' ) || ( c > '9' ) )
		{
			if (  c == '.' )
				error = 0;
			else
			{
				if ( ( c == '-' ) && ( count == 0 ) )
					error = 0;
				else
				{
					char msg[26];
					sprintf ( msg, "Error: '%c' non-numeric.", c );
					messageDialogManager->post( msg );
					error = 1;
				}
			}
		}
	}

	if ( error )
	{
		// assume invalid, pop up format msg
		char msg[BUFSIZE];
		snprintf ( msg, sizeof ( msg ), "Invalid format %s",  text );
		msg [ sizeof ( msg ) - 1 ] = 0;
		messageDialogManager->post ( msg );
	}
	
	return error;
}


void ModifyArrayCmd::stripName ( char *path )
{
	unsigned int i = strlen ( path );
	unsigned int j = 0;

	while  ( ( path[i] != '/' ) && ( i >= 0 ) )
		i--;
	
	i++;
	
	while ( i < strlen ( path ) )
	{
		if ( j == LABELSIZE )
			i = strlen ( path );
		else
		{
			_labelString[j] = path[i];
			i++;
			j++;
		}
	}
	
	_labelString[j] = 0;
}
